//-----------------------------------------------------------------------
// <copyright file="MockServiceModelIClientChannel.cs" company="NMock2">
//
//   http://www.sourceforge.net/projects/NMock2
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
// </copyright>
// This is the easiest way to ignore StyleCop rules on this file, even if we shouldn't use this tag:
// <auto-generated />
//-----------------------------------------------------------------------

namespace NMock2.AcceptanceTests
{
    using System;
    using NUnit.Framework;

    /// <summary>
    /// Reproduction of the defect 2609020 - Firing an event of an inherited interface
    /// </summary>
    [TestFixture]
    public class FireInheritedEvent_2609020 : AcceptanceTestBase
    {
        /// <summary>
        /// Interface providing an event.
        /// </summary>
        public interface IBase
        {
            event EventHandler Event;
        }

        /// <summary>
        /// The interface we create a mock for. Inherits from <see cref="IBase"/>.
        /// </summary>
        public interface IDerived : IBase
        {
        }

        /// <summary>
        /// The inherited event can be fired.
        /// </summary>
        [Test]
        public void FireInheritedEvent()
        {
            IDerived mock = Mocks.NewMock<IDerived>();

            Fire.Event("Event").On(mock).With(this, EventArgs.Empty);
        }
    }
}