//-----------------------------------------------------------------------
// <copyright file="IGenerics.cs" company="NMock2">
//
//   http://www.sourceforge.net/projects/NMock2
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
// </copyright>
// This is the easiest way to ignore StyleCop rules on this file, even if we shouldn't use this tag:
// <auto-generated />
//-----------------------------------------------------------------------
namespace NMock2.AcceptanceTests
{
    public interface IGenericHelloWorld : IHelloWorld
    {
        T Find<T>();
        T Find<T, U>();
        bool Save<T>(T persistentObject);

        T ReadVariable<T>(string name);
        void SetVariable<T>(string name, T val);

        T Cast<U, T>(U value);
    }

    public abstract class GenericHelloWorld : IGenericHelloWorld
    {
        #region IGenericHelloWorld members

        public abstract T Find<T>();
        public abstract T Find<T, U>();
        public abstract bool Save<T>(T persistentObject);

        public abstract T ReadVariable<T>(string name);
        public abstract void SetVariable<T>(string name, T val);

        public abstract T Cast<U, T>(U value);

        #endregion

        #region IHelloWorld members

        public abstract void Hello();
        public abstract void Umm();
        public abstract void Err();
        public abstract void Ahh();
        public abstract void Goodbye();
        public abstract string Ask(string question);

        #endregion
    }
}
