namespace NMock2
{
    using NUnit.Framework;

    [TestFixture]
    public class MockMethodsFromObjectTest
    {
        private Mockery mockery;

        [SetUp]
        public void SetUp()
        {
            this.mockery = new Mockery();
        }

        [TearDown]
        public void TearDown()
        {
            this.mockery.VerifyAllExpectationsHaveBeenMet();
        }

        [Test]
        public void MockToStringOnClass()
        {
            TestClass mock = this.mockery.NewMock<TestClass>();

            Expect.Once.On(mock).Method("ToString").Will(Return.Value("whatYouWant"));

            string s = mock.ToString();
            Assert.AreEqual("whatYouWant", s);
        }

        [Test]
        public void MockToStringOnInterface()
        {
            ITestInterface mock = this.mockery.NewMock<ITestInterface>();

            Expect.Once.On(mock).Method("ToString").Will(Return.Value("whatYouWant"));

            string s = mock.ToString();
            Assert.AreEqual("whatYouWant", s);
        }

        public class TestClass
        {
        }

        public interface ITestInterface
        {
        }
    }
}