//-----------------------------------------------------------------------
// <copyright file="StubAcceptanceTest.cs" company="NMock2">
//
//   http://www.sourceforge.net/projects/NMock2
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
// </copyright>
// This is the easiest way to ignore StyleCop rules on this file, even if we shouldn't use this tag:
// <auto-generated />
//-----------------------------------------------------------------------
namespace NMock2.AcceptanceTests
{
    using NUnit.Framework;

    [TestFixture]
    public class StubAcceptanceTest : AcceptanceTestBase
    {
        [Test]
        public void StubsDoNotHaveToBeCalled()
        {
            IHelloWorld helloWorld = (IHelloWorld)Mocks.NewMock(typeof(IHelloWorld));
            
            Stub.On(helloWorld).Method("Hello").WithAnyArguments();
        }
        
        [Test]
        public void StubsCanBeCalledAnyNumberOfTimes()
        {
            IHelloWorld helloWorld = (IHelloWorld)Mocks.NewMock(typeof(IHelloWorld));
            
            Stub.On(helloWorld).Method("Hello").WithAnyArguments();
            
            for (int i = 0; i < ANY_NUMBER; i++) helloWorld.Hello();
        }
        
        [Test]
        public void StubsMatchArgumentsAndPerformActionsJustLikeAnExpectation()
        {
            IHelloWorld helloWorld = (IHelloWorld)Mocks.NewMock(typeof(IHelloWorld));

            Stub.On(helloWorld).Method("Ask").With("Name").Will(Return.Value("Bob"));
            Stub.On(helloWorld).Method("Ask").With("Age").Will(Return.Value("30"));
            
            for (int i = 0; i < ANY_NUMBER; i++)
            {
                Verify.That(helloWorld.Ask("Name"), Is.EqualTo("Bob"), "Name");
                Verify.That(helloWorld.Ask("Age"), Is.EqualTo("30"), "Age");
            }
        }
        
        #region Don't look in here...
        #region	I told you not to look in here!
        const int ANY_NUMBER = 10;
        #endregion
        #endregion
    }
}
