//-----------------------------------------------------------------------
// <copyright file="SetIndexedParameterActionTest.cs" company="NMock2">
//
//   http://www.sourceforge.net/projects/NMock2
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
// </copyright>
// This is the easiest way to ignore StyleCop rules on this file, even if we shouldn't use this tag:
// <auto-generated />
//-----------------------------------------------------------------------
namespace NMock2.Test.Actions
{
    using System.Reflection;
    using NMock2.Actions;
    using NMock2.Monitoring;
    using NMock2.Test.Monitoring;
    using NUnit.Framework;
    
    [TestFixture]
    public class SetIndexedParameterActionTest
    {
        [Test]
        public void SetsIndexedParameterOnInvocation()
        {
            object receiver = new object();
            MethodInfoStub methodInfo = new MethodInfoStub("method",
                new ParameterInfoStub("p1",ParameterAttributes.In),
                new ParameterInfoStub("p2",ParameterAttributes.Out));
            int index = 1;
            object value = new object();
            Invocation invocation = new Invocation(receiver, methodInfo, new object[]{null,null});
            
            SetIndexedParameterAction action = new SetIndexedParameterAction(index,value);
            
            action.Invoke(invocation);
            
            Assert.AreSame( value, invocation.Parameters[index], "set value" );
        }

        [Test]
        public void HasReadableDescription()
        {
            int index = 1;
            object value = new NamedObject("value");
            
            SetIndexedParameterAction action = new SetIndexedParameterAction(index,value);
            
            AssertDescription.IsEqual(action, "set arg 1=<value>");
        }
    }
}
