//-----------------------------------------------------------------------
// <copyright file="DescriptionWriterTest.cs" company="NMock2">
//
//   http://www.sourceforge.net/projects/NMock2
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
// </copyright>
// <auto-generated />
//-----------------------------------------------------------------------
namespace NMock2.Internal.Test
{
    using NUnit.Framework;
    using NMock2.Internal;

    [TestFixture]
    public class DescriptionWriterTest
    {
        DescriptionWriter writer;
        
        [SetUp]
        public void InitialiseWriter()
        {
            writer = new DescriptionWriter();
        }
        
        [Test]
        public void FormatsStringsInCSharpSyntaxWhenWrittenAsObject()
        {
            object aString = "hello \"world\"";
            writer.Write(aString);
            
            Assert.AreEqual("\"hello \\\"world\\\"\"", writer.ToString());
        }

        [Test]
        public void FormatsNullAsNull()
        {
            writer.Write((object)null);
            Assert.AreEqual("null", writer.ToString());
        }

        [Test]
        public void HighlightsOtherValuesWhenWrittenAsObject()
        {
            object anInt = 1;
            writer.Write(anInt);

            Assert.AreEqual("<1>", writer.ToString());
        }
    }
}
