﻿//-----------------------------------------------------------------------
// <copyright file="DescriptionOverrideTest.cs" company="NMock2">
//
//   http://www.sourceforge.net/projects/NMock2
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
// </copyright>
// This is the easiest way to ignore StyleCop rules on this file, even if we shouldn't use this tag:
// <auto-generated />
//-----------------------------------------------------------------------
namespace NMock2.Test.Matchers
{
    using NUnit.Framework;
    using NMock2.Matchers;
    
    [TestFixture]
    public class DescriptionOverrideTest
    {
        [Test]
        public void DelegatesMatchingToAnotherMatcher()
        {
            Matcher m1 = new DescriptionOverride("irrelevant", new AlwaysMatcher(true, "always true"));
            Matcher m2 = new DescriptionOverride("irrelevant", new AlwaysMatcher(false, "always false"));

            Assert.IsTrue(m1.Matches(new object()), "m1");
            Assert.IsFalse(m2.Matches(new object()), "m2");
        }

        [Test]
        public void OverridesDescriptionOfOtherMatcherWithThatPassedToConstructor()
        {
            Matcher m1 = new DescriptionOverride("m1", new AlwaysMatcher(true, "always true"));
            Matcher m2 = new DescriptionOverride("m2", new AlwaysMatcher(false, "always false"));

            AssertDescription.IsEqual(m1, "m1");
            AssertDescription.IsEqual(m2, "m2");
        }
    }
}
