using System;
using System.Collections.Generic;
using System.Text;

namespace NMock2
{
	/// <summary>
	/// Specifies how a mock object should behave when it is first created.
	/// </summary>
	public enum MockStyle
	{
		/// <summary>
		/// Calls to members that do not have expectations set will
		/// result in ExpectationExceptions.
		/// </summary>
		Default = 0,

		/// <summary>
		/// Calls to members that do not have expectations set will
		/// pass through to the underlying implementation on the class
		/// being mocked.
		/// </summary>
		Transparent = 1
	}
}
